/* Agent Library Common

    ΏۃfoCXF
    EATtiny44A/84A
    
    gpF
    E8MHzNbNi0.125usjvXP[Ȃ
    
    F
    lF

*/

#include <avr/eeprom.h>
#include "actuate.h"

volatile uint8_t act_num=ACT0;                                                  // AN`G[^o͎ ACTnum: ACT0/ACT2/ACT4/ACT6/ACT8
uint8_t EEMEM bitassign[8]={1,2,0,3,4,5,6,7};                                   // o̓rbgATCe[uiEEPROMj
uint8_t convassign[8];                                                          // o̓rbgATCe[uiRAMj

// ACTp^ϊ
//yzACTp^(ϊO)
//yߒlzACTp^(ϊ)
uint8_t convact(uint8_t act_data) {
    uint8_t act_conv;                                                           // ϊp^
    uint8_t temp_bit,i,j;
    
    act_conv = 0;                                                               // 
    for (i=0;i<act_num;i++) {
        j = convassign[i];                                                      // ϊ̃rbgʒu#j
        temp_bit = ((1<<i) & act_data)>>i;                                      // ϊrbg(#i)U LSBɂĂ
        act_conv |= temp_bit << j;                                              // LSB ϊ̃rbgʒu#jɂ
    }
    return act_conv;                                                            // ϊp^Ԃ
}

// ACTo
//yzACTp^(8bit)
//yߒlzȂ
void actuate(uint8_t act_data) {

    // rbgATCϊGmIWinjbg̏ꍇ̂ݎ{iACT6/8j
    if (act_num >= ACT6) {
        act_data = convact(act_data);
    }

    // ACTo̓|[gւ̃}bsO
    #if defined (__AVR_ATtiny44A__) || defined (__AVR_ATtiny84A__)
    
    /*    
        ACT2,4: PB0,PA6..08sgp
        PA6/4/2/0VNo͂Ƃĉ^p(o͎ɂkxɗƂ)BPA5/3/1͓vAbvłgxɌŒB
        Ȃ PB0͏o͐ݒƂ邪kx̂܂܌ŒBACT4HPB0sGNDڑč\B
        
        ACT-bit0  PA0 Ƀ}bsO
        ACT-bit1  PA2 Ƀ}bsO
        ACT-bit2  PA4 Ƀ}bsO USI SCL: I2C_DISABLED̂ݎgp
        ACT-bit3  PA6 Ƀ}bsO USI SDA: I2C_DISABLED̂ݎgp
        
        ACT6,8: PB0,PA6..08sgp
         PA7̓pXo(OC0B)Ŏgp
        
        ACT-bit0  PA3 Ƀ}bsO
        ACT-bit1  PA2 Ƀ}bsO
        ACT-bit2  PA5 Ƀ}bsO
        ACT-bit3  PA1 Ƀ}bsO
        ACT-bit4  PB0 Ƀ}bsO
        ACT-bit5  PA0 Ƀ}bsO
        ACT-bit6  PA4 Ƀ}bsO USI SCL: I2C_DISABLED̂ݎgp
        ACT-bit7  PA6 Ƀ}bsO USI SDA: I2C_DISABLED̂ݎgp
    */
    
    // ACTo̓|[g
    switch (act_num) {
    case ACT2:
        PORTA |=  ACT2_PORTA_MASK;                                              // PA2/0 ZbgiftHgnCj
        PORTB &= ~ACT2_PORTB_MASK;                                              // PB0 ZbgiftHg[j
        break;
    case ACT4:
        PORTA |=  ACT4_PORTA_MASK;                                              // PA6/4/2/0 ZbgiftHgnCj
        PORTB &= ~ACT4_PORTB_MASK;                                              // PB0 ZbgiftHg[j
        break;
    case ACT6:
        PORTA &= ~ACT6_PORTA_MASK;                                              // PA5/3..0 Zbg
        PORTB &= ~ACT6_PORTB_MASK;                                              // PB0 Zbg
        break;
    case ACT8:
        PORTA &= ~ACT8_PORTA_MASK;                                              // PA6..0 Zbg
        PORTB &= ~ACT8_PORTB_MASK;                                              // PB0 Zbg
        break;
    default:
        break;
    }
    
    // o̓rbg|[gɃ}bsO
    switch (act_num) {
    case ACT2:
    case ACT4:
        // VNo
        PORTA &= ~((act_data & ACT_MASK_BIT0) >> 0);                            // bit0  PA0 Ƀ}bsO
        PORTA &= ~((act_data & ACT_MASK_BIT1) << 1);                            // bit1  PA2 Ƀ}bsO
        if (act_num == ACT4) {
            PORTA &= ~((act_data & ACT_MASK_BIT2) << 2);                        // bit2  PA4 Ƀ}bsO
            PORTA &= ~((act_data & ACT_MASK_BIT3) << 3);                        // bit3  PA6 Ƀ}bsO
        }
        break;
    case ACT6:
    case ACT8:
        // \[Xo
        PORTA |= ((act_data & ACT_MASK_BIT0) << 3);                             // bit0  PA3 Ƀ}bsO
        PORTA |= ((act_data & ACT_MASK_BIT1) << 1);                             // bit1  PA2 Ƀ}bsO
        PORTA |= ((act_data & ACT_MASK_BIT2) << 3);                             // bit2  PA5 Ƀ}bsO
        PORTA |= ((act_data & ACT_MASK_BIT3) >> 2);                             // bit3  PA1 Ƀ}bsO
        PORTB |= ((act_data & ACT_MASK_BIT4) >> 4);                             // bit4  PB0 Ƀ}bsO
        PORTA |= ((act_data & ACT_MASK_BIT5) >> 5);                             // bit5  PA0 Ƀ}bsO
        if (act_num == ACT8) {
            PORTA |= ((act_data & ACT_MASK_BIT6) >> 2);                         // bit6  PA4 Ƀ}bsO
            PORTA |= ((act_data & ACT_MASK_BIT7) >> 1);                         // bit7  PA6 Ƀ}bsO
        }
        break;
    default:
        break;
    }
    
    #elif defined (__AVR_ATtiny2313__) || defined (__AVR_ATtiny4313__)
    // TODO:ACT6ȊOւ̑Ή
    // PB6,PB4..1,PD66sgp
    // ACT-bit4..1  PB4..1 ɂ̂܂܃}bsO
    // ACT-bit5  PB6 Ƀ}bsO
    // ACT-bit0  PD6 Ƀ}bsO
    //  PB7, PB5USIŎgpCPB0̓ZbgAgpɊmہi}`vZbTj

    // AN`G[^o̓|[g
    PORTB &= ACT_INIT_PB;                                                       // PB6,PB4..1 Zbg
    PORTD &= ~(1<<PD6);                                                         // PD6 Zbg
    
    // o̓f[^Y|[gɃ}bsO
    PORTB |= act_data & ACT_MASK_BIT4321;                                       // bit4..1  PB4..1 ɂ̂܂܃}bsO
    PORTB |= ((act_data & ACT_MASK_BIT5) << 1);                                 // bit5  PB6 Ƀ}bsO
    PORTD |= ((act_data & ACT_MASK_BIT0) << 6);                                 // bit0  PD6 Ƀ}bsO
    
    #elif defined (__AVR_ATmega88P__) || defined(__AVR_ATmega88PA__)
    // TODO:ACT6ȊOւ̑Ή
    // PC0,PB5..16sgp
    // ACT-bit4..0  PB5..1 ɃVtgă}bsO
    // ACT-bit5  PC0 Ƀ}bsO
    //  PB0̓ZbgAgpɊmہi}`vZbTj

    // AN`G[^o̓|[g
    PORTB &= ACT_INIT_PB;                                                       // PB5..1 Zbg
    PORTC &= ~(1<<PC0);                                                         // PC0 Zbg
    
    // o̓f[^Y|[gɃ}bsO
    PORTB |= ((act_data & ACT_MASK_BIT43210) << 1);                             // bit4..0  PB5..1 ɃVtgă}bsO
    PORTC |= ((act_data & ACT_MASK_BIT5) >> 5);                                 // bit5  PC0 Ƀ}bsO
    
    #endif
}